<div *ngIf="!loadedInitially" class="loader">
  <mat-spinner></mat-spinner>
</div>

<mat-card *ngIf="loadedInitially && (meeting$ | async)" style="margin-bottom: 50px;">
  <mat-card-title>Meeting</mat-card-title>
  <mat-card-subtitle>The appointment you have booked is scheduled for now. Please initiate the call yourself with one of the following methods:</mat-card-subtitle>
  <mat-card-content>
    <mat-accordion>
      <!-- Hangouts -->
      <mat-expansion-panel>
        <mat-expansion-panel-header>
          <mat-panel-title>
            Google Hangouts
          </mat-panel-title>
        </mat-expansion-panel-header>

        <h3>1. Please go to <a href="https://hangouts.google.com/" target="_blank" style="color: blue;">the Hangouts call page <mat-icon>open_in_new</mat-icon></a></h3>
        <h3>2. Please use the following email address for making the call: yuttadhammo@gmail.com</h3>
      </mat-expansion-panel>

      <!-- Discord -->
      <mat-expansion-panel *ngIf="(meeting$ | async).discordLink">
        <mat-expansion-panel-header>
          <mat-panel-title>
            Discord
          </mat-panel-title>
        </mat-expansion-panel-header>

        <h3>1. Please use the following link to join the appointments discord channel: <a [href]="(meeting$ | async).discordLink" target="_blank" style="color: blue;">{{ (meeting$ | async).discordLink }}</a></h3>
        <h3>2. Please join the voice channel named "appointment"</h3>
        <h3>3. For sending the initial notification to Bhante please click on the following button: </h3>

        <div class="notification-success mat-subheading-1" *ngIf="(meeting$ | async).initiated || (meetingInitiateSuccess$ | async)">
          <mat-icon>check</mat-icon>
          <span>Notification has been sent</span>
        </div>

        <button *ngIf="!(meeting$ | async).initiated && !(meetingInitiateSuccess$ | async)" mat-raised-button color="primary" [disabled]="(meetingInitiatePending$ | async)" (click)="initiateMeeting()">
          <mat-spinner
            *ngIf="(meetingInitiatePending$ | async)"
            [diameter]="22"
            [strokeWidth]="2"
            class="in-button-spinner">
          </mat-spinner>
          Initiate Call
        </button>
        <h4 *ngIf="(meetingInitiateError$ | async)" style="color: red;">{{ (meetingInitiateError$ | async) }}</h4>
      </mat-expansion-panel>
    </mat-accordion>
  </mat-card-content>
  <mat-card-actions>
    <a mat-button href="https://gitlab.com/sirimangalo/meditation-plus/wikis/Appointments" target="_blank">
      <span>Help</span>
      <mat-icon>open_in_new</mat-icon>
    </a>
  </mat-card-actions>
</mat-card>

<mat-card class="first-card" *ngIf="loadedInitially">
  <p>Please come to this page once your appointment is due. You can find instructions on how to initiate it <a href="https://gitlab.com/sirimangalo/meditation-plus/wikis/Appointments" target="__blank">in the Wiki</a>.</p>
  
  <p *ngIf="!(meeting$ | async) && ownAppointment">Your next appointment starts <b>{{ getCountdownForOwnAppointment() }}</b></p>
  <p *ngIf="profileTz">The table shows appointments in your profile's timezone: <b>{{ profileTz }}</b></p>
  <p *ngIf="!profileTz && browserTz">The table shows appointments in your browser's timezone: <b>{{ browserTz }}</b> (You can change the timezone in your profile settings)</p>
  <!-- mode: table view -->
  <table class="appointment-table" *ngIf="currentTab === 'table' && appointmentsByHour && appointmentHours">
    <tr>
      <th>Time</th>
      <th>Mo</th>
      <th>Tu</th>
      <th>We</th>
      <th>Th</th>
      <th>Fr</th>
      <th>Sa</th>
      <th>Su</th>
    </tr>
    <tr *ngFor="let hour of appointmentHours">
      <td>
        {{ hour }}
      </td>
      <td *ngFor="let day of [1, 2, 3, 4, 5, 6, 0]">
        <span *ngFor="let app of appointmentsByHour[hour]">
          <span *ngIf="app.localDay === day">
            <a *ngIf="app.user && app.user._id !== (userId$ | async)" class="taken-appointment"
               [class.admin-appointment]="(admin$ | async)"
               (click)="removeRegistration($event, app)"
            >
              <span class="appointment-username">{{ app.user.name }}</span>
              <span class="appointment-taken">taken</span>
            </a>
            <a href="#"
              *ngIf="app.user && app.user._id === (userId$ | async)"
              class="my-appointment"
              (click)="toggleRegistration($event, app)"
            >
              <span class="appointment-username">{{ app.user.name }}</span>
              <span class="appointment-taken">my</span>
            </a>
            <a href="#"
              *ngIf="!app.user"
              class="free-appointment"
              (click)="toggleRegistration($event, app)"
            >
              free
            </a>
          </span>
        </span>
      </td>
    </tr>
  </table>

  <!-- mode: list view -->
  <mat-list class="appointment-list" *ngIf="currentTab === 'list' && appointmentsByDay">
    <div>
      <mat-checkbox [(ngModel)]="listViewShowBookable">
        Show free appointments as well
      </mat-checkbox>
    </div>
    <div *ngFor="let day of [1, 2, 3, 4, 5, 6, 0]">
      <div *ngIf="appointmentsByDay[day]">
        <h4>
          {{ getWeekday(day) }}
        </h4>
        <div *ngFor="let app of appointmentsByDay[day]">

          <!-- appointment with user -->
          <mat-list-item class="appointment-row" *ngIf="app.user">
            <img
              [routerLink]="app.user.username ? ['/profile', app.user.username] : ['/profile/id', app.user._id]"
              mat-list-avatar
              avatar
              [username]="app.user.username"
              [token]="app.user.avatarImageToken"
              [size]="40">
            <h3 mat-line>
              <b><a [routerLink]="app.user.username ? ['/profile', app.user.username] : ['/profile/id', app.user._id]">{{ app.user.name }}</a></b>
            </h3>
            <p mat-line>
              {{ app.localHour }}
            </p>
            <mat-icon *ngIf="(admin$ | async)" (click)="removeRegistration($event, app)">delete</mat-icon>
            <mat-icon *ngIf="!(admin$ | async) && app.user._id === (userId$ | async)" (click)="toggleRegistration($event, app)">delete</mat-icon>
          </mat-list-item>
          
          <!-- appointment without user -->
          <mat-list-item class="appointment-row" *ngIf="listViewShowBookable && !app.user">
            <h3 mat-line>FREE</h3>
            <p mat-line>
              {{ app.localHour }}
            </p>
            <button
              mat-raised-button
              color="primary"
              (click)="toggleRegistration($event, app)"
            >
              BOOK
            </button>
          </mat-list-item>
        </div>
      </div>
    </div>
  </mat-list>
</mat-card>
<mat-card class="primary-card">
  <ul>
    <li>
      This page is for those practicing formal meditation daily who would like to undertake a formal meditation course over the Internet.
    </li>
    <li>
      Book an appointment using the table below by clicking on the appropriate box.
    </li>
    <li>
      When the time for your meeting arrives, please visit the appointment page (schedule).
    </li>
    <li>
      <b>You must initiate the appointment yourself.</b> You will not receive a call from the teacher.
    </li>
    <li>
      <b>Please note that if you miss an appointment without notifying us, your reservation will be cancelled.</b>
    </li>
    <li>
      You will need headphones and a microphone, and preferably a webcam as well.
    </li>
    <li>
      Please check if the time in the table is displayed and converted correctly.
    </li>
  </ul>
</mat-card>
